package de.unikoblenz.fgbks.api.test;

import de.unikoblenz.fgbks.core.dmn.domain.Name;
import de.unikoblenz.fgbks.core.test.Person;
import de.unikoblenz.fgbks.core.test.Synonyms;
import javax.inject.Inject;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import org.eclipse.microprofile.config.inject.ConfigProperty;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Path("/hello")
public class GreetingResource {

  private static Logger LOGGER = LoggerFactory.getLogger("test");

  @Inject WordnetServiceX wordnetServiceX;

  @ConfigProperty(name = "hello")
  private String greet;

  @GET
  @Produces(MediaType.APPLICATION_JSON)
  public Response hello() {
    return Response.accepted(new Person(new Name(greet + " Jonas"))).build();
  }

  @GET
  @Produces(MediaType.APPLICATION_JSON)
  @Consumes(MediaType.TEXT_PLAIN)
  @Path("/{word}")
  public Response hello(@PathParam("word") String word) {
    return Response.accepted(new Synonyms(wordnetServiceX.getNounsSynonyms(word))).build();
  }

  @GET
  @Produces(MediaType.TEXT_PLAIN)
  @Consumes(MediaType.TEXT_PLAIN)
  @Path("/{word1}/{word2}")
  public String hello(@PathParam("word1") String word1, @PathParam("word2") String word2) {
    return Boolean.toString(wordnetServiceX.areNounsSynonyms(word1, word2));
  }
}
